<template>
  <div>
    <div style="margin: 3rem">
      <el-header style="margin-top:10rem">
        <ReturnButton  :offsetArrow="19" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage" style="margin:0 0 2rem 12rem"></ReturnButton>
        <!-- buscador -->
         <el-row :gutter="20" style="margin: 3rem 0">
          <!-- Filtros -->
          <el-col :span="19" :offset="4">
            <el-col :span="9">
              <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
            </el-col>
            <el-col :span="11">
              <!-- <app-search-filter v-model="textSearch"></app-search-filter> -->
              <el-input 
                class="input-head"
                placeholder="Buscar"
                prefix-icon="el-icon-search"
                v-model="textSearch"
                @clear="cleanSearch"
                clearable>
              </el-input> 
            </el-col>
            <el-col :span="2">
              <el-button @click="filterMaterials" type="primary" v-if="textSearch"> BUSCAR </el-button>   
              <el-button @click="filterMaterials" type="primary" v-else disabled> BUSCAR </el-button>       
            </el-col>
          </el-col>
        </el-row>
        <!-- titulo -->
        <el-col :offset="2" :span="20" class="bg-dark-gray " style="padding:10px 20px">
          <h3 class="text-white">ALMACÉN DE MATERIALES ENLATADOS</h3>
        </el-col>
      </el-header>
      <el-main style="margin-top:10rem; margin-left:8%; width:84%; min-height: 300px">
        <el-row style="margin-top: 30px">
          <el-col v-for="(contract, index) in searching.slice(0,20)" :key="index" v-loading="loading" :element-loading-text="loadingText">
            <app-cards-canned 
              :principalTitle="contract.contractName" firstText="Cod. Proveedor" 
              :valuetext="contract.providerCode" secondMainText="MATERIALES" secondtext="Total de Materiales:" :secondvaluetext="contract.admittedMaterials.length" 
              thirdtext="Materiales recibidos:" :thirdvaluetext="receivedMat(contract)" fourthtext="Materiales Almacenados:" :fourthvaluetext="storedMat(contract)" 
              :anArray="contract.admittedMaterials" :filtStatus="filtStatus" :valueTitle='valueTitle'  :nameButton="contract.statusContractStorage" :nameType="contract.nameTypeStorage" @buttonState="clickButton(contract._id, contract)" :color="color"
              :listTitleValue="contract.refMaterials">
            </app-cards-canned>
          </el-col>
          <el-col v-if="searching && searching.length == 0" v-loading="loading" :element-loading-text="loadingText">
            <el-col :span="20" :offset="2" v-show="!loading">      
              <el-card :body-style="{ padding: '0px' }" class="bg-gray">
                <el-col :span="8" style="margin-top: 1rem" class="text-center">
                  <img src="../../../assets/images/detective.svg" alt="">
                </el-col>
                <el-col :span="16">
                  <div style="margin-top: 5rem">
                    <p class="title-styles">¡Lo sentimos!</p>
                    <p class="title-styles">No encontramos resultados para tu búsqueda </p>
                  </div>
                </el-col>
              </el-card>
            </el-col>
          </el-col>
        </el-row>
      </el-main>
    </div>
  </div>
</template>
<script>
import SearchFilter from '@/components/searchFilter.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import { modifyText } from '../../../utils/modifyText.js'
import Select from '@/components/AppSelect.vue'
import CardsCanned from '@/components/cardsCanned.vue'
import { HTTP } from '../../../main.js'

export default {
  components: {
    ReturnButton,
    'app-search-filter': SearchFilter,
    'app-cards-canned': CardsCanned,
    'app-select': Select,

  },

  data () {
    return {
      filterSelect: '',
      textSearch: '',
      valueTitle: 'listTitle',
      statebutton:'PENDIENTE',
      color:'text-orange',
      filtStatus:'statusMaterial',
      allFilters: [
        // {value: 'contractName', label: 'Nombre Proveedor'},
        {value: 'providerCode', label: 'Código Proveedor'},
        {value: 'codMaterial', label: 'Código Material'}
      ],
      loading: true,
      loadingText: 'Cargando Materiales Enlatados...',
      // copyStorageContracts: JSON.parse(this.$localStorage.get("allContracts")),
      isShowNoResults: false,
      IsClick: false
    }
  },
  computed:{
    searching () {
      try {
        let a
        if(this.IsClick) {
         a = this.$store.getters.getProgramsFilters
        }
        else {
         a =  this.$store.getters.allContracts 
         this.IsClick = false
        }
        a = a.filter(
          m => m.confirmedStatus == 'confirmed' &&  m.typeContract == "Enlatados"
        )
        return a
      } catch (e) {
        console.log(e)
      }
    }
  },
  created () {
    this.receivedMat ()
    this.verifyContent()
  },
  methods: {
    filterMaterials () {
      let cadenaConexion

      if (this.filterSelect == '' &&  this.textSearch !== '' ) {   
        cadenaConexion =  HTTP.get(`contracts/typeOfFilter/contractName/word/${this.textSearch}`)
      }
      else {       
        cadenaConexion =  HTTP.get(`contracts/typeOfFilter/${this.filterSelect}/word/${this.textSearch}`)
      }
      cadenaConexion
      .then(res=> {
        this.isShowNoResults = res.data.contracts.length == 0  ? true : false
        this.$store.dispatch('SELECTED_PROGRAMS', res.data.contracts)
        this.IsClick = true
      })
    },
    cleanSearch() {
      this.filterSelect =  ''
      this.isShowNoResults = false
      this.IsClick = false
    },
    receivedMat (contract) {
      if(contract){
        // conteo de materiales recibidos
        let materialsReceived = []
        contract.admittedMaterials.map((mat)=>{
          if( mat.statusMaterial === 3 || mat.statusMaterial === 2 ){
            materialsReceived.push(mat)
          }
        })
        return materialsReceived.length
      }
    },
    storedMat (contract) {
      // conteo materiales almacenados
      if(contract) {
        // console.log(contract)
        let storeMaterial = []
        contract.admittedMaterials.map((mat)=>{
          if( mat.statusStorage === 3 ){
            storeMaterial.push(mat)
          }
        })
        return storeMaterial.length
      }
    },
    returnPage() {
      this.$router.push({ name: 'cannedMaterials' })
    },
    async clickButton (id, contract) {
      // boton que muestra pendiente, incompleto o completo
      let idStorageMat = id
      let sendContract = contract
      console.log (sendContract, 'sendContract')
      this.$store.dispatch('setContractReceived', sendContract)
      this.$store.dispatch('setIdStorageMat', idStorageMat)
      this.$store.commit('setContractForStorageCanned', await this.getContractEspecific(id))
      this.$router.push('storageCannedMat')
    },
    async getContractEspecific(id) {
      try {
        const response = await HTTP.get(`contracts/${id}`)
        const {contract} = await response.data
        return contract
      } catch (err) {
        console.log(err, 'error getContractEspecific')
      }
    },
    verifyContent() {
      if(this.searching.length > 0) {
        this.loading = false
      } else {
          this.loading = this.searching.length == 0 && this.textSearch !== '' ? false : true
      }
    },
  },
  watch: {
    searching(val) {
      this.verifyContent()
    }
  }
}
</script>

